program DeLo;

{$IFDEF COMMENT}
DeLo - Delphi Loader, Version 1.0
Autor: Andre Morales-Bahnik
       Schneidemhler Str. 25
       76139 Karlsruhe
       CIS 100102.1210

Weitere Informationen finden Sie in der Datei "DeLo.txt".       
{$ENDIF}

uses Windows, Messages, IniFiles, Registry;

{$R *.RES}

{$D DeLo - Delphi Loader, Version 1.0}

function EnumWindowsProc(Handle: integer; LParam: longint): boolean; stdcall;
var
 Menu: integer;
 MenuItemInfo: TMenuItemInfo;
 WindowPlacement: TWindowPlacement;
begin
 WindowPlacement.Length:=SizeOf(WindowPlacement);
 if IsWindowVisible(Handle) then
 begin
  if GetWindowPlacement(Handle,@WindowPlacement) then
  begin
   if WindowPlacement.ShowCmd<>SW_SHOWMINIMIZED then
   begin
    Menu:=GetSystemMenu(Handle,False);
    MenuItemInfo.cbSize:=SizeOf(MenuItemInfo);
    MenuItemInfo.fMask:=MIIM_STATE;
    if GetMenuItemInfo(Menu,SC_MINIMIZE,False,MenuItemInfo) then
    begin
     if MenuItemInfo.fState=MFS_ENABLED then
     begin
      SendMessage(Handle,WM_SYSCOMMAND,SC_MINIMIZE,0);
     end;
    end;
   end;
  end;
 end;
 Result:=True;
end;

var
 AppName,MessageStr: string;
 StartUpInfo: TStartUpInfo;
 ProcessInfo: TProcessInformation;
 WinIniFile: TIniFile;
 RegFile: TRegistry;
 WinDir: string;
 Wallpaper: string;

begin
 RegFile:=TRegistry.Create;
 RegFile.RootKey:=HKEY_LOCAL_MACHINE;
 if RegFile.OpenKey('SOFTWARE\Borland\Delphi\2.0',False) then
 begin
  try
   AppName:=RegFile.ReadString('Delphi 2.0');
  except
   on ERegistryException do
   begin
    MessageStr:='Kann Delphi 2.0 nicht finden.';
    MessageBox(0,PChar(MessageStr),NIL,MB_OK);
    RegFile.Free;
    Exit;
   end;
  end;
  EnumWindows(@EnumWindowsProc,0);
  SetLength(WinDir,MAX_PATH);
  SetLength(WinDir,GetWindowsDirectory(PChar(WinDir),MAX_PATH));
  WinIniFile:=TIniFile.Create(WinDir+'\WIN.INI');
  Wallpaper:=WinIniFile.ReadString('Desktop','Wallpaper','');
  MessageStr:='[Kein]';
  SystemParametersInfo(SPI_SETDESKWALLPAPER,0,PChar(MessageStr),SPIF_UPDATEINIFILE);
  with StartUpInfo do
  begin
   cb:=SizeOf(StartUpInfo);
   lpReserved:=NIL;
   lpDesktop:=NIL;
   lpTitle:=NIL;
   dwFlags:=STARTF_USESHOWWINDOW;
   wShowWindow:=SW_SHOWNORMAL;
   cbReserved2:=0;
   lpReserved2:=NIL;
  end;
  if CreateProcess(PChar(AppName),NIL,NIL,NIL,False,0,NIL,NIL,StartUpInfo,ProcessInfo) then
  begin
   WaitForSingleObject(ProcessInfo.hProcess,INFINITE);
  end
  else
  begin
   MessageStr:='Kann Delphi 2.0 nicht starten.';
   MessageBox(0,PChar(MessageStr),NIL,MB_OK);
  end;
 end
 else
 begin
  MessageStr:='Kann Delphi 2.0 nicht finden.';
  MessageBox(0,PChar(MessageStr),NIL,MB_OK);
 end;
 RegFile.Free;
 WinIniFile.Free;
 SystemParametersInfo(SPI_SETDESKWALLPAPER,0,PChar(Wallpaper),SPIF_UPDATEINIFILE);
end.
